/*
 * Copyright (C) 2007 Pleyo.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Pleyo nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PLEYO AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL PLEYO OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef WidgetImpl_h
#define WidgetImpl_h

#include "Widget.h"
#include "BINativeImage.h"
#include "BTScrollView.h"
#include <font/Font.h>
#include <graphics/IntRect.h>

namespace WebCore {

    class WidgetClient;

    class WidgetPrivate {
        public:
            WidgetPrivate()
                : m_backingStore(NULL)
                , client(NULL)
                , x(0)
                , y(0)
                , width(0)
                , height(0)
                , m_parent(0)
                , m_isEnabled(true)
            {}
            BAL::BINativeImage *m_backingStore;
            WebCore::IntRect m_dirtyRect;
            WidgetClient* client;
            IntRect geometry;
            BAL::Font font;
            int x;
            int y;
            int width;
            int height;
            BAL::BTScrollView* m_parent;
            bool m_isEnabled;
    };

}

using WebCore::WidgetPrivate;
using WebCore::Widget;
#endif // WidgetImpl_h
