cmake_minimum_required(VERSION 2.6)

SET( CMAKE_SYSTEM_NAME Linux)

IF (NOT "$ENV{TQTVD_DISABLE_COMPILER_TEST}" STREQUAL "")
# Disable C commpiler test performed by cmake (this platform can't generate independent executable binaries)
SET( CMAKE_C_COMPILER_WORKS "_")
# Disable C++ commpiler test performed by cmake (this platform can't generate independent executable binaries)
SET( CMAKE_CXX_COMPILER_WORKS "_")
ENDIF()

SET (TQTVD_TARGET $ENV{TQTVD_TARGET})

SET( GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS TRUE)

SET( CMAKE_MODULE_PATH $ENV{SDK}/common/cmake-2.6.1-Linux-i386/Modules)

SET( ASTRONAV_TARGET_DEPLOY $ENV{ASTRONAV_TARGET_DEPLOY})

SET( SDK                    $ENV{SDK} )
SET( PREFIX                 $ENV{PREFIX} )
SET( COMMON                 $ENV{COMMON} )

SET(GLOBAL CMAKE_AR     $ENV{AR})
SET(GLOBAL CMAKE_RANLIB $ENV{RANLIB})
SET(CMAKE_C_COMPILER    $ENV{GCC})
SET(CMAKE_CXX_COMPILER  $ENV{CXX})
SET(CMAKE_STRIP_CUSTOM  $ENV{STRIP})

INCLUDE_DIRECTORIES(
    ${CONFIGSROOT}
    $ENV{CONFIGSROOT}/
    $ENV{SDKROOT}/boost
    $ENV{BASE_DIR}/general
    $ENV{SDK}/curl/include
    $ENV{SDK}/xml/include/libxml2
)

LINK_DIRECTORIES(
    ${SDK}/apollo/mtk_obj/obj/rel/basic/lib/
)

# Enable to generate astronav lib
SET (TQTVD_BUILD_ASTRONAV "$ENV{TQTVD_BUILD_ASTRONAV}")

ADD_DEFINITIONS (-DTQTVD_XHTML_TABLE_SIZE=1024)

# Platform-specific definitions
ADD_DEFINITIONS( -D_NO_SIGHANDLER_SUPPORT)
ADD_DEFINITIONS( -DBOOST_STRICT_CONFIG )
ADD_DEFINITIONS( -DBOOST_SP_USE_PTHREADS )
ADD_DEFINITIONS( -DTQTVD_END_OF_LINE="\\n\\r" )
ADD_DEFINITIONS (-D_NO_SIGHANDLER_SUPPORT ) 
ADD_DEFINITIONS (-DTQTVD_MEMORY_ALIGNMENT_BOUNDARY=8)

# CMake find root paths 
SET( CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
SET( CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
SET( CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
